diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_hungarian.c b/src/backend/snowball/libstemmer/stem_UTF_8_hungarian.c
index e40df8e6c1..d8ae15aeab 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_hungarian.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_hungarian.c
@@ -979,161 +766,29 @@ static int r_sing_owner(struct SN_env * z) {
     return 1;
 }
 
-static int r_plur_owner(struct SN_env * z) {
+static int r_plur_owner(struct SN_env * z) { /* backwardmode */
     int among_var;
     z->ket = z->c; /* [, line 193 */
-    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((10768 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0;
-    among_var = find_among_b(z, a_11, 42); /* substring, line 193 */
+    if (z->c <= z->lb || z->p[z->c - 1] >> 5 != 3 || !((10768 >> (z->p[z->c - 1] & 0x1f)) & 1)) return 0; /* substring, line 193 */
+    among_var = find_among_b(z, a_11, 42);
     if (!(among_var)) return 0;
     z->bra = z->c; /* ], line 193 */
-    {   int ret = r_R1(z);
-        if (ret == 0) return 0; /* call R1, line 193 */
-        if (ret < 0) return ret;
+    {   int ret = r_R1(z); /* call R1, line 193 */
+        if (ret <= 0) return ret;
     }
-    switch(among_var) {
-        case 0: return 0;
+    switch (among_var) { /* among, line 193 */
         case 1:
             {   int ret = slice_del(z); /* delete, line 194 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 1, s_24); /* <-, line 195 */
+            {   int ret = slice_from_s(z, 1, s_12); /* <-, line 195 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_from_s(z, 1, s_25); /* <-, line 196 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 4:
-            {   int ret = slice_del(z); /* delete, line 197 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 5:
-            {   int ret = slice_del(z); /* delete, line 198 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 6:
-            {   int ret = slice_del(z); /* delete, line 199 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 7:
-            {   int ret = slice_from_s(z, 1, s_26); /* <-, line 200 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 8:
-            {   int ret = slice_from_s(z, 1, s_27); /* <-, line 201 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 9:
-            {   int ret = slice_del(z); /* delete, line 202 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 10:
-            {   int ret = slice_del(z); /* delete, line 203 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 11:
-            {   int ret = slice_del(z); /* delete, line 204 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 12:
-            {   int ret = slice_from_s(z, 1, s_28); /* <-, line 205 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 13:
-            {   int ret = slice_from_s(z, 1, s_29); /* <-, line 206 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 14:
-            {   int ret = slice_del(z); /* delete, line 207 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 15:
-            {   int ret = slice_del(z); /* delete, line 208 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 16:
-            {   int ret = slice_del(z); /* delete, line 209 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 17:
-            {   int ret = slice_del(z); /* delete, line 210 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 18:
-            {   int ret = slice_from_s(z, 1, s_30); /* <-, line 211 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 19:
-            {   int ret = slice_from_s(z, 1, s_31); /* <-, line 212 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 20:
-            {   int ret = slice_del(z); /* delete, line 214 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 21:
-            {   int ret = slice_del(z); /* delete, line 215 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 22:
-            {   int ret = slice_from_s(z, 1, s_32); /* <-, line 216 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 23:
-            {   int ret = slice_from_s(z, 1, s_33); /* <-, line 217 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 24:
-            {   int ret = slice_del(z); /* delete, line 218 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 25:
-            {   int ret = slice_del(z); /* delete, line 219 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 26:
-            {   int ret = slice_del(z); /* delete, line 220 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 27:
-            {   int ret = slice_from_s(z, 1, s_34); /* <-, line 221 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 28:
-            {   int ret = slice_from_s(z, 1, s_35); /* <-, line 222 */
-                if (ret < 0) return ret;
-            }
-            break;
-        case 29:
-            {   int ret = slice_del(z); /* delete, line 223 */
+            {   int ret = slice_from_s(z, 1, s_13); /* <-, line 196 */
                 if (ret < 0) return ret;
             }
             break;
@@ -1141,10 +796,10 @@ static int r_plur_owner(struct SN_env * z) {
     return 1;
 }
 
-extern int hungarian_UTF_8_stem(struct SN_env * z) {
+extern int hungarian_UTF_8_stem(struct SN_env * z) { /* forwardmode */
     {   int c1 = z->c; /* do, line 229 */
-        {   int ret = r_mark_regions(z);
-            if (ret == 0) goto lab0; /* call mark_regions, line 229 */
+        {   int ret = r_mark_regions(z); /* call mark_regions, line 229 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
@@ -1153,72 +808,72 @@ extern int hungarian_UTF_8_stem(struct SN_env * z) {
     z->lb = z->c; z->c = z->l; /* backwards, line 230 */
 
     {   int m2 = z->l - z->c; (void)m2; /* do, line 231 */
-        {   int ret = r_instrum(z);
-            if (ret == 0) goto lab1; /* call instrum, line 231 */
+        {   int ret = r_instrum(z); /* call instrum, line 231 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = z->l - m2;
     }
     {   int m3 = z->l - z->c; (void)m3; /* do, line 232 */
-        {   int ret = r_case(z);
-            if (ret == 0) goto lab2; /* call case, line 232 */
+        {   int ret = r_case(z); /* call case, line 232 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
     lab2:
         z->c = z->l - m3;
     }
     {   int m4 = z->l - z->c; (void)m4; /* do, line 233 */
-        {   int ret = r_case_special(z);
-            if (ret == 0) goto lab3; /* call case_special, line 233 */
+        {   int ret = r_case_special(z); /* call case_special, line 233 */
+            if (ret == 0) goto lab3;
             if (ret < 0) return ret;
         }
     lab3:
         z->c = z->l - m4;
     }
     {   int m5 = z->l - z->c; (void)m5; /* do, line 234 */
-        {   int ret = r_case_other(z);
-            if (ret == 0) goto lab4; /* call case_other, line 234 */
+        {   int ret = r_case_other(z); /* call case_other, line 234 */
+            if (ret == 0) goto lab4;
             if (ret < 0) return ret;
         }
     lab4:
         z->c = z->l - m5;
     }
     {   int m6 = z->l - z->c; (void)m6; /* do, line 235 */
-        {   int ret = r_factive(z);
-            if (ret == 0) goto lab5; /* call factive, line 235 */
+        {   int ret = r_factive(z); /* call factive, line 235 */
+            if (ret == 0) goto lab5;
             if (ret < 0) return ret;
         }
     lab5:
         z->c = z->l - m6;
     }
     {   int m7 = z->l - z->c; (void)m7; /* do, line 236 */
-        {   int ret = r_owned(z);
-            if (ret == 0) goto lab6; /* call owned, line 236 */
+        {   int ret = r_owned(z); /* call owned, line 236 */
+            if (ret == 0) goto lab6;
             if (ret < 0) return ret;
         }
     lab6:
         z->c = z->l - m7;
     }
     {   int m8 = z->l - z->c; (void)m8; /* do, line 237 */
-        {   int ret = r_sing_owner(z);
-            if (ret == 0) goto lab7; /* call sing_owner, line 237 */
+        {   int ret = r_sing_owner(z); /* call sing_owner, line 237 */
+            if (ret == 0) goto lab7;
             if (ret < 0) return ret;
         }
     lab7:
         z->c = z->l - m8;
     }
     {   int m9 = z->l - z->c; (void)m9; /* do, line 238 */
-        {   int ret = r_plur_owner(z);
-            if (ret == 0) goto lab8; /* call plur_owner, line 238 */
+        {   int ret = r_plur_owner(z); /* call plur_owner, line 238 */
+            if (ret == 0) goto lab8;
             if (ret < 0) return ret;
         }
     lab8:
         z->c = z->l - m9;
     }
     {   int m10 = z->l - z->c; (void)m10; /* do, line 239 */
-        {   int ret = r_plural(z);
-            if (ret == 0) goto lab9; /* call plural, line 239 */
+        {   int ret = r_plural(z); /* call plural, line 239 */
+            if (ret == 0) goto lab9;
             if (ret < 0) return ret;
         }
     lab9:
